Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.joda.time
Class Weeks

    java.lang.Object
      org.joda.time.base.BaseSingleFieldPeriod
          org.joda.time.Weeks

All Implemented Interfaces:
  java.io.Serializable, java.lang.Comparable, ReadablePeriod

    public final class Weeks

extends BaseSingleFieldPeriod

An immutable time period representing a number of weeks.

`Weeks` is an immutable period that can only store weeks. It does not store years, months or hours for example. As such it is a type-safe way of representing a number of weeks in an application.

The number of weeks is set in the constructor, and may be queried using `getWeeks()`. Basic mathematical operations are provided - `plus()`, `minus()`, `multipliedBy()` and `dividedBy()`.

`Weeks` is thread-safe and immutable.

Since:
  1.4
Author:
  Stephen Colebourne
See Also:
  Serialized Form

Field Summary
`static Weeks` | `MAX_VALUE` Constant representing the maximum nuber of weeks that can be stored in this object.
`static Weeks` | `MIN_VALUE` Constant representing the minimum nuber of weeks that can be stored in this object.
`static Weeks` | `ONE` Constant representing one week.
`static Weeks` | `THREE` Constant representing three weeks.
`static Weeks` | `TWO` Constant representing two weeks.
`static Weeks` | `ZERO` Constant representing zero weeks.

Method Summary
`Weeks` | `dividedBy(int divisor)` Returns a new instance with the weeks divided by the specified divisor.
`DurationFieldType` | `getFieldType()` Gets the duration field type, which is `weeks`.
`PeriodType` | `getPeriodType()` Gets the period type, which is `weeks`.
`int` | `getWeeks()` Gets the number of weeks that this period represents.
`boolean` | `isGreaterThan(Weeks other)` Is this weeks instance greater than the specified number of weeks.
`boolean` | `isLessThan(Weeks other)` Is this weeks instance less than the specified number of weeks.
`Weeks` | `minus(int weeks)` Returns a new instance with the specified number of weeks taken away.
`Weeks` | `minus(Weeks weeks)` Returns a new instance with the specified number of weeks taken away.
`Weeks` | `multipliedBy(int scalar)` Returns a new instance with the weeks multiplied by the specified scalar.
`Weeks` | `negated()` Returns a new instance with the weeks value negated.
`static Weeks` | `parseWeeks(java.lang.String periodStr)` Creates a new `Weeks` by parsing a string in the ISO8601 format 'PnW'.
`Weeks` | `plus(int weeks)` Returns a new instance with the specified number of weeks added.
`Weeks` | `plus(Weeks weeks)` Returns a new instance with the specified number of weeks added.
`static Weeks` | `standardWeeksIn(ReadablePeriod period)` Creates a new `Weeks` representing the number of complete standard length weeks in the specified period.
`Days` | `toStandardDays()` Converts this period in weeks to a period in days assuming a 7 day week.
`Duration` | `toStandardDuration()` Converts this period in weeks to a duration in milliweeks assuming a 7 day week, 24 hour day, 60 minute hour and 60 second minute.
`Hours` | `toStandardHours()` Converts this period in weeks to a period in hours assuming a 7 day week and 24 hour day.
`Minutes` | `toStandardMinutes()` Converts this period in weeks to a period in minutes assuming a 7 day week, 24 hour day and 60 minute hour.
`Seconds` | `toStandardSeconds()` Converts this period in weeks to a period in seconds assuming a 7 day week, 24 hour day, 60 minute hour and 60 second minute.
`java.lang.String` | `toString()` Gets this instance as a String in the ISO8601 duration format.
`static Weeks` | `weeks(int weeks)` Obtains an instance of `Weeks` that may be cached.
`static Weeks` | `weeksBetween(ReadableInstant start, ReadableInstant end)` Creates a `Weeks` representing the number of whole weeks between the two specified datetimes.
`static Weeks` | `weeksBetween(ReadablePartial start, ReadablePartial end)` Creates a `Weeks` representing the number of whole weeks between the two specified partial datetimes.
`static Weeks` | `weeksIn(ReadableInterval interval)` Creates a `Weeks` representing the number of whole weeks in the specified interval.

Methods inherited from class org.joda.time.base.BaseSingleFieldPeriod
`between, between, compareTo, equals, get, getFieldType, getValue, getValue, hashCode, isSupported, setValue, size, standardPeriodIn, toMutablePeriod, toPeriod`

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### ZERO

    public static final Weeks ZERO

  Constant representing zero weeks.

### ONE

    public static final Weeks ONE

  Constant representing one week.

### TWO

    public static final Weeks TWO

  Constant representing two weeks.

### THREE

    public static final Weeks THREE

  Constant representing three weeks.

### MAX_VALUE

    public static final Weeks MAX_VALUE

  Constant representing the maximum nuber of weeks that can be stored in this object.

### MIN_VALUE

    public static final Weeks MIN_VALUE

  Constant representing the minimum nuber of weeks that can be stored in this object.

Method Detail

### weeks

    public static Weeks weeks(int weeks)

  Obtains an instance of `Weeks` that may be cached. `Weeks` is immutable, so instances can be cached and shared. This factory method provides access to shared instances.

  Parameters:
    `weeks` - the number of weeks to obtain an instance for
  Returns:
    the instance of Weeks

### weeksBetween

    public static Weeks weeksBetween(ReadableInstant start,
                                     ReadableInstant end)

  Creates a `Weeks` representing the number of whole weeks between the two specified datetimes.

  Parameters:
    `start` - the start instant, must not be null
    `end` - the end instant, must not be null
  Returns:
    the period in weeks
  Throws:
    `java.lang.IllegalArgumentException` - if the instants are null or invalid

### weeksBetween

    public static Weeks weeksBetween(ReadablePartial start,
                                     ReadablePartial end)

  Creates a `Weeks` representing the number of whole weeks between the two specified partial datetimes.

  The two partials must contain the same fields, for example you can specify two `LocalDate` objects.

  Parameters:
    `start` - the start partial date, must not be null
    `end` - the end partial date, must not be null
  Returns:
    the period in weeks
  Throws:
    `java.lang.IllegalArgumentException` - if the partials are null or invalid

### weeksIn

    public static Weeks weeksIn(ReadableInterval interval)

  Creates a `Weeks` representing the number of whole weeks in the specified interval.

  Parameters:
    `interval` - the interval to extract weeks from, null returns zero
  Returns:
    the period in weeks
  Throws:
    `java.lang.IllegalArgumentException` - if the partials are null or invalid

### standardWeeksIn

    public static Weeks standardWeeksIn(ReadablePeriod period)

  Creates a new `Weeks` representing the number of complete standard length weeks in the specified period.

  This factory method converts all fields from the period to hours using standardised durations for each field. Only those fields which have a precise duration in the ISO UTC chronology can be converted.

  - One week consists of 7 days.
  - One day consists of 24 hours.
  - One hour consists of 60 minutes.
  - One minute consists of 60 weeks.
  - One second consists of 1000 milliseconds.
  Months and Years are imprecise and periods containing these values cannot be converted.

  Parameters:
    `period` - the period to get the number of hours from, null returns zero
  Returns:
    the period in weeks
  Throws:
    `java.lang.IllegalArgumentException` - if the period contains imprecise duration values

### parseWeeks

    public static Weeks parseWeeks(java.lang.String periodStr)

  Creates a new `Weeks` by parsing a string in the ISO8601 format 'PnW'.

  The parse will accept the full ISO syntax of PnYnMnWnDTnHnMnS however only the weeks component may be non-zero. If any other component is non-zero, an exception will be thrown.

  Parameters:
    `periodStr` - the period string, null returns zero
  Returns:
    the period in weeks
  Throws:
    `java.lang.IllegalArgumentException` - if the string format is invalid

### getFieldType

    public DurationFieldType getFieldType()

  Gets the duration field type, which is `weeks`.

  Specified by:
    `getFieldType` in class `BaseSingleFieldPeriod`
  Returns:
    the period type

### getPeriodType

    public PeriodType getPeriodType()

  Gets the period type, which is `weeks`.

  Specified by:
    `getPeriodType` in interface `ReadablePeriod`
  Specified by:
    `getPeriodType` in class `BaseSingleFieldPeriod`
  Returns:
    the period type

### toStandardDays

    public Days toStandardDays()

  Converts this period in weeks to a period in days assuming a 7 day week.

  This method allows you to convert between different types of period. However to achieve this it makes the assumption that all weeks are 7 days long. This may not be true for some unusual chronologies. However, it is included as it is a useful operation for many applications and business rules.

  Returns:
    a period representing the number of days for this number of weeks
  Throws:
    `java.lang.ArithmeticException` - if the number of days is too large to be represented

### toStandardHours

    public Hours toStandardHours()

  Converts this period in weeks to a period in hours assuming a 7 day week and 24 hour day.

  This method allows you to convert between different types of period. However to achieve this it makes the assumption that all weeks are 7 days long and all days are 24 hours long. This is not true when daylight savings is considered and may also not be true for some unusual chronologies. However, it is included as it is a useful operation for many applications and business rules.

  Returns:
    a period representing the number of hours for this number of weeks
  Throws:
    `java.lang.ArithmeticException` - if the number of hours is too large to be represented

### toStandardMinutes

    public Minutes toStandardMinutes()

  Converts this period in weeks to a period in minutes assuming a 7 day week, 24 hour day and 60 minute hour.

  This method allows you to convert between different types of period. However to achieve this it makes the assumption that all weeks are 7 days long, all days are 24 hours long and all hours are 60 minutes long. This is not true when daylight savings is considered and may also not be true for some unusual chronologies. However, it is included as it is a useful operation for many applications and business rules.

  Returns:
    a period representing the number of minutes for this number of weeks
  Throws:
    `java.lang.ArithmeticException` - if the number of minutes is too large to be represented

### toStandardSeconds

    public Seconds toStandardSeconds()

  Converts this period in weeks to a period in seconds assuming a 7 day week, 24 hour day, 60 minute hour and 60 second minute.

  This method allows you to convert between different types of period. However to achieve this it makes the assumption that all weeks are 7 days long, all days are 24 hours long, all hours are 60 minutes long and all minutes are 60 seconds long. This is not true when daylight savings is considered and may also not be true for some unusual chronologies. However, it is included as it is a useful operation for many applications and business rules.

  Returns:
    a period representing the number of seconds for this number of weeks
  Throws:
    `java.lang.ArithmeticException` - if the number of seconds is too large to be represented

### toStandardDuration

    public Duration toStandardDuration()

  Converts this period in weeks to a duration in milliweeks assuming a 7 day week, 24 hour day, 60 minute hour and 60 second minute.

  This method allows you to convert from a period to a duration. However to achieve this it makes the assumption that all weeks are 7 days long, all days are 24 hours long, all hours are 60 minutes long and all minutes are 60 seconds long. This is not true when daylight savings time is considered, and may also not be true for some unusual chronologies. However, it is included as it is a useful operation for many applications and business rules.

  Returns:
    a duration equivalent to this number of weeks

### getWeeks

    public int getWeeks()

  Gets the number of weeks that this period represents.

  Returns:
    the number of weeks in the period

### plus

    public Weeks plus(int weeks)

  Returns a new instance with the specified number of weeks added.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `weeks` - the amount of weeks to add, may be negative
  Returns:
    the new period plus the specified number of weeks
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### plus

    public Weeks plus(Weeks weeks)

  Returns a new instance with the specified number of weeks added.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `weeks` - the amount of weeks to add, may be negative, null means zero
  Returns:
    the new period plus the specified number of weeks
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### minus

    public Weeks minus(int weeks)

  Returns a new instance with the specified number of weeks taken away.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `weeks` - the amount of weeks to take away, may be negative
  Returns:
    the new period minus the specified number of weeks
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### minus

    public Weeks minus(Weeks weeks)

  Returns a new instance with the specified number of weeks taken away.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `weeks` - the amount of weeks to take away, may be negative, null means zero
  Returns:
    the new period minus the specified number of weeks
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### multipliedBy

    public Weeks multipliedBy(int scalar)

  Returns a new instance with the weeks multiplied by the specified scalar.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `scalar` - the amount to multiply by, may be negative
  Returns:
    the new period multiplied by the specified scalar
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### dividedBy

    public Weeks dividedBy(int divisor)

  Returns a new instance with the weeks divided by the specified divisor. The calculation uses integer division, thus 3 divided by 2 is 1.

  This instance is immutable and unaffected by this method call.

  Parameters:
    `divisor` - the amount to divide by, may be negative
  Returns:
    the new period divided by the specified divisor
  Throws:
    `java.lang.ArithmeticException` - if the divisor is zero

### negated

    public Weeks negated()

  Returns a new instance with the weeks value negated.

  Returns:
    the new period with a negated value
  Throws:
    `java.lang.ArithmeticException` - if the result overflows an int

### isGreaterThan

    public boolean isGreaterThan(Weeks other)

  Is this weeks instance greater than the specified number of weeks.

  Parameters:
    `other` - the other period, null means zero
  Returns:
    true if this weeks instance is greater than the specified one

### isLessThan

    public boolean isLessThan(Weeks other)

  Is this weeks instance less than the specified number of weeks.

  Parameters:
    `other` - the other period, null means zero
  Returns:
    true if this weeks instance is less than the specified one

### toString

    public java.lang.String toString()

  Gets this instance as a String in the ISO8601 duration format.

  For example, "P4W" represents 4 weeks.

  Specified by:
    `toString` in interface `ReadablePeriod`
  Overrides:
    `toString` in class `java.lang.Object`
  Returns:
    the value as an ISO8601 string

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD